header
{
/**
 * Semantic analysis for the Mile Language.
 * 
 * @author Ricardo Soto
 * @since 1.5
 */

package cl.ucv.inf.milecompiler.compilers;

}

  
class MileTreeParser extends TreeParser;
options
{
    importVocab=MileParserVocab;
    buildAST = false;
    defaultErrorHandler=false;
}

{
private SemanticInspector   sI = new SemanticInspector();
}

//==================================================
//Program

program  : #(PROGRAM var_dec body);

var_dec  : #(VAR_DEC (type id:IDENT {sI.addVar(id);})*);

type : NUMERIC_TYPE|STRING_TYPE;


body : #(BODY assign);

assign : #(ASSIGN ( id:IDENT {sI.checkVar(id);} ASSIG expr));
        
//=================================================
//Expressions

expr
  : #(OR_RW           expr expr) 
  | #(AND_RW          expr expr) 
  | #(EQUAL           expr expr) 
  | #(GR_EQUAL        expr expr)  
  | #(NOT_EQUAL       expr expr) 
  | #(GR              expr expr) 
  | #(LE              expr expr) 
  | #(PLUS            expr expr) 
  | #(SUB             expr expr) 
  | #(STAR            expr expr) 
  | #(SLASH           expr expr) 

  | #(UN_MINUS                   expr)
  | #(RES_NOT                    expr) 
  | id:IDENT  {sI.checkVar(id);}
  | lit
  ;

  lit: REAL_LITERAL|INT_LITERAL;